//
//  _AppAppDelegate.m
//  4App
//
//  Created by valvoline on 11/2/10.
//  Copyright 2010 Universita  di Catania. All rights reserved.
//

#import "_AppAppDelegate.h"
#import "MyView.h"

@implementation _AppAppDelegate

@synthesize window;


#pragma mark -
#pragma mark Application lifecycle

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {    
	//Non allochiamo la window e non la inizializziamo perche' stiamo utilizzando il file XIB MainWindow
	//configurato nel file _App-Info.plist come risorsa principale usata dalla classe AppDelegate.
    [window makeKeyAndVisible];
	
	//creiamo una UIScrollView programmaticamente
	UIScrollView *aScrollView = [[UIScrollView alloc] initWithFrame:[[UIScreen mainScreen] bounds]];

	//alcune proprieta'...
	[aScrollView setContentSize:CGSizeMake(640, 960)];
	[aScrollView setMinimumZoomScale:0.5];
	[aScrollView setMaximumZoomScale:5];
	[aScrollView setDelegate:self];

	//creiamo un'oggetto di tipo MyView, meglio specificato nei files di classe 
	//MyView.h (interfaccia) e MyView.m (implementazione)
	MyView *aView = [[MyView alloc] initWithFrame:CGRectMake(0, 0, 640, 960)];

	//aggiungiamo la sua istanza alla scrollview
	[aScrollView addSubview:aView];
	
	//deleghiamo la responsabilità per la gestione della memoria allocata dall'oggetto di tipo MyView
	//alla classe ricevete (aScrollView), dopo l'operazione di addSubview.
	[aView release];
	
	//aggiungiamo la scrollview alla finestra principale (UIWindow)
	[window addSubview:aScrollView];
	
	//perche' rilasciamo l'oggetto?
	[aScrollView release];
    return YES;
}

//metodo delegato implementato
-(UIView *)viewForZoomingInScrollView:(UIScrollView *)scrollView {
	return scrollView;
}

#pragma mark Memory management
- (void)applicationDidReceiveMemoryWarning:(UIApplication *)application {
    /*
     Free up as much memory as possible by purging cached data objects that can be recreated (or reloaded from disk) later.
     */
}

- (void)dealloc {
    [window release];
    [super dealloc];
}


@end
